# @metaplex-foundation/umi-core

## 0.8.6

### Patch Changes

- [`aba3519`](https://github.com/metaplex-foundation/umi/commit/aba35199c9f481b5aaf81f812ce945e07796a6aa) Thanks [@lorisleiva](https://github.com/lorisleiva)! - Fix formatDateTime helper function

## 0.8.5

### Patch Changes

- Updated dependencies [[`281b12f`](https://github.com/metaplex-foundation/umi/commit/281b12f052ed343c1d5ed25335a3efe283f7809f), [`f12af8e`](https://github.com/metaplex-foundation/umi/commit/f12af8e0127bea479155e73c6d4730ee94736ac7)]:
  - @metaplex-foundation/umi-options@0.8.5
  - @metaplex-foundation/umi-serializers@0.8.5

## 0.8.4

### Patch Changes

- [`d1e0c09`](https://github.com/metaplex-foundation/umi/commit/d1e0c09550bf07fe8bc0865f9732f025c3d8dafe) Thanks [@lorisleiva](https://github.com/lorisleiva)! - Extract confirm method in TransactionBuilder

- [`99bf51d`](https://github.com/metaplex-foundation/umi/commit/99bf51d6f58d7fe5b73d7678478ac8463c87d857) Thanks [@lorisleiva](https://github.com/lorisleiva)! - Add RPC options to builder's setLatestBlockhash method

## 0.8.2

### Patch Changes

- [#68](https://github.com/metaplex-foundation/umi/pull/68) [`4accd34`](https://github.com/metaplex-foundation/umi/commit/4accd34f0a70d360321c42f395a2ad45cbadca16) Thanks [@lorisleiva](https://github.com/lorisleiva)! - Extract serializer modules and use in core umi library

- [#66](https://github.com/metaplex-foundation/umi/pull/66) [`4342375`](https://github.com/metaplex-foundation/umi/commit/43423750c9b351446b868ede57ecb634cebde42a) Thanks [@lorisleiva](https://github.com/lorisleiva)! - Accept Nullable as Option input when serializing

- [#66](https://github.com/metaplex-foundation/umi/pull/66) [`4342375`](https://github.com/metaplex-foundation/umi/commit/43423750c9b351446b868ede57ecb634cebde42a) Thanks [@lorisleiva](https://github.com/lorisleiva)! - Add isOption and wrapNullable helpers

- Updated dependencies [[`4accd34`](https://github.com/metaplex-foundation/umi/commit/4accd34f0a70d360321c42f395a2ad45cbadca16)]:
  - @metaplex-foundation/umi-public-keys@0.8.2
  - @metaplex-foundation/umi-serializers@0.8.2
  - @metaplex-foundation/umi-options@0.8.2

## 0.8.1

### Patch Changes

- [#64](https://github.com/metaplex-foundation/umi/pull/64) [`bc11e6e`](https://github.com/metaplex-foundation/umi/commit/bc11e6e6f964594c75d04f78ef6c86a87aae6749) Thanks [@lorisleiva](https://github.com/lorisleiva)! - Add new helpers to unwrap options recursively

## 0.8.0

### Minor Changes

- [#62](https://github.com/metaplex-foundation/umi/pull/62) [`15392cd`](https://github.com/metaplex-foundation/umi/commit/15392cd9a98d55750be09268c8ee93611d159e03) Thanks [@lorisleiva](https://github.com/lorisleiva)! - Define PublicKeys as base58 strings

  See PR #62

  The `PublicKey` type is now a `string` instead of a `{ bytes: Uint8Array }`. This was done to:

  - make the end-user API simpler.
  - make public keys "pure" values that can easily be shared and logged.
  - make Umi's API closer to the new web3.js library (See [the `@solana/keys` package](https://github.com/solana-labs/solana-web3.js/blob/6524b01189cd4917da62fe78a33fef58bd692986/packages/keys/src/base58.ts)).

  If you are already using the `publicKey` helper to create public keys, your code should continue working as-is. Otherwise, you will need to pass in the base58 representation of your public keys instead of the previous object representation.

  ```ts
  // Before.
  const pubkeyA = publicKey('4HM9LW2rm3SR2ZdBiFK3D21ENmQWpqEJEhx1nfgcC3r9');
  const bytesOfPubkeyB = new Uint8Array(Array(32).fill(0));
  const pubkeyB = { bytes: bytesOfPubkeyB };

  // After.
  const pubkeyA = publicKey('4HM9LW2rm3SR2ZdBiFK3D21ENmQWpqEJEhx1nfgcC3r9'); // ✅ No changes needed.
  const bytesOfPubkeyB = new Uint8Array(Array(32).fill(0));
  const pubkeyB = publicKey(bytesOfPubkeyB); // 🚧 Use the `publicKey` helper to convert to a `PublicKey` string.
  const pubkeyB = publicKey('11111111111111111111111111111111'); // 🚧 Or pass in the base58 string directly.
  ```

  Note that the `Pda` type has also been adjusted since it can no longer extend the `PublicKey` type (as it is now a primitive value and not an object). Instead, the `Pda` type is now defined as the following tuple `[PublicKey, number]`. If you are using a Kinobi-generated library, they have been updated to ensure that you can pass either a `PublicKey` or a `Pda` in various generated method to avoid any breaking change. That being said, if you are using PDAs directly you may need to update your code as showed below:

  ```ts
  // Before.
  const pdaA = findSomePda(umi, seedsA);
  await fetchSomeAccount(umi, pdaA);

  const pdaB = findSomePda(umi, seedsB);
  await umi.rpc.getAccount(pdaB);

  // After.
  const pdaA = findSomePda(umi, seedsA);
  await fetchSomeAccount(umi, pdaA); // ✅ No changes needed as generated methods now accept PublicKey | Pda.

  const [publicKeyB] = findSomePda(umi, seedsB); // 🚧 Destructure the Pda to get the PublicKey...
  await umi.rpc.getAccount(publicKeyB); // ...because `getAccount` requires a `PublicKey`.
  ```

## 0.7.14

### Patch Changes

- [#58](https://github.com/metaplex-foundation/umi/pull/58) [`f530089`](https://github.com/metaplex-foundation/umi/commit/f5300891d0bad4b13431a11d87bfa35b6881ae56) Thanks [@lorisleiva](https://github.com/lorisleiva)! - Ensure nested serializer is padded when using fixSerializer

## 0.7.13

### Patch Changes

- [#54](https://github.com/metaplex-foundation/umi/pull/54) [`6a33ea3`](https://github.com/metaplex-foundation/umi/commit/6a33ea32937f37cb34114582f2c365ac21c6d8e5) Thanks [@lorisleiva](https://github.com/lorisleiva)! - Add support for cloning a program repository

- [#54](https://github.com/metaplex-foundation/umi/pull/54) [`6a33ea3`](https://github.com/metaplex-foundation/umi/commit/6a33ea32937f37cb34114582f2c365ac21c6d8e5) Thanks [@lorisleiva](https://github.com/lorisleiva)! - Add program bindings

## 0.7.11

### Patch Changes

- [`38c98dc`](https://github.com/metaplex-foundation/umi/commit/38c98dcc7c61ce212198381765b80fa695c51fa7) Thanks [@lorisleiva](https://github.com/lorisleiva)! - Fix wrong content-type when uploading a JSON file

## 0.7.10

### Patch Changes

- [`c1c1da6`](https://github.com/metaplex-foundation/umi/commit/c1c1da6bbed341492c3d81a4edc7aebb43471345) Thanks [@lorisleiva](https://github.com/lorisleiva)! - Add getBlockTime RPC method

- [`1139bcf`](https://github.com/metaplex-foundation/umi/commit/1139bcfedc541d6b89df2d61b10c4fdc169c4eee) Thanks [@lorisleiva](https://github.com/lorisleiva)! - Add mapInstructions and addRemainingAccounts helpers

## 0.7.7

### Patch Changes

- [#45](https://github.com/metaplex-foundation/umi/pull/45) [`bf9b550`](https://github.com/metaplex-foundation/umi/commit/bf9b550ae945f3963f2c96361b7d7ab38921c6a7) Thanks [@lorisleiva](https://github.com/lorisleiva)! - Add TransactionBuilderGroup

## 0.7.6

### Patch Changes

- [`5b275d5`](https://github.com/metaplex-foundation/umi/commit/5b275d53680d66fcd77b1b09a30bf101036e22b3) Thanks [@lorisleiva](https://github.com/lorisleiva)! - Fix deserializeAccount type parameters

## 0.7.5

### Patch Changes

- [`670e7d4`](https://github.com/metaplex-foundation/umi/commit/670e7d4ba00e41802226ee7c722a116ef141891f) Thanks [@lorisleiva](https://github.com/lorisleiva)! - Add getSignatureStatuses to RpcInterface

## 0.7.4

### Patch Changes

- [`3718fae`](https://github.com/metaplex-foundation/umi/commit/3718faeafc28400313aa93f8e4db3945218ffb0b) Thanks [@lorisleiva](https://github.com/lorisleiva)! - Support custom discriminator sizes for enums

- [`00cb767`](https://github.com/metaplex-foundation/umi/commit/00cb7671976a63670bd71b70a06d5452b0761f62) Thanks [@lorisleiva](https://github.com/lorisleiva)! - Deprecate checkForIsWritableOverride function

- [`f56fc59`](https://github.com/metaplex-foundation/umi/commit/f56fc59eee0deebf347e22a097c19aca1332a52a) Thanks [@lorisleiva](https://github.com/lorisleiva)! - Accept Web3.js public keys as input of publicKey()

## 0.7.2

### Patch Changes

- [`2756a69`](https://github.com/metaplex-foundation/umi/commit/2756a693fb1d5d1a90608744ca73165b663cc729) Thanks [@lorisleiva](https://github.com/lorisleiva)! - Fix Base64 serializer

## 0.7.0

### Minor Changes

- [#34](https://github.com/metaplex-foundation/umi/pull/34) [`a963320`](https://github.com/metaplex-foundation/umi/commit/a9633202645a23b19c00ec973e93f5e5fda0776d) Thanks [@lorisleiva](https://github.com/lorisleiva)! - Use functions instead of classes to implement interfaces

## 0.6.0

### Minor Changes

- [#28](https://github.com/metaplex-foundation/umi/pull/28) [`b1e898f`](https://github.com/metaplex-foundation/umi/commit/b1e898fb8f78eb3b7acedd6b77dcdfd161164b00) Thanks [@lorisleiva](https://github.com/lorisleiva)! - Defer context in TransactionBuilder until needed

## 0.5.3

### Patch Changes

- [`c20d154`](https://github.com/metaplex-foundation/umi/commit/c20d15448537a93d7fe7a5f4765e0d3880ccc8cf) Thanks [@lorisleiva](https://github.com/lorisleiva)! - Add getPublicKey method to ProgramRepositoryInterface

- [`13acda9`](https://github.com/metaplex-foundation/umi/commit/13acda9d8c968716289e47b3e19b888f8ba11857) Thanks [@lorisleiva](https://github.com/lorisleiva)! - Add bitArray serializer

## 0.5.2

### Patch Changes

- [`3db36d1`](https://github.com/metaplex-foundation/umi/commit/3db36d13e281a171f407e9652e2404d54c2971bd) Thanks [@lorisleiva](https://github.com/lorisleiva)! - Make GpaBuilder fields more flexible

## 0.5.1

### Patch Changes

- [#24](https://github.com/metaplex-foundation/umi/pull/24) [`27276f4`](https://github.com/metaplex-foundation/umi/commit/27276f4ab5865bd55a5682990c5e48aa2d9b10cd) Thanks [@lorisleiva](https://github.com/lorisleiva)! - Rename umi, umi-core and umi-test

## 0.4.1

### Patch Changes

- [#22](https://github.com/metaplex-foundation/umi/pull/22) [`807b469`](https://github.com/metaplex-foundation/umi/commit/807b4691ed843f6a4247317362d71b6457ad291d) Thanks [@lorisleiva](https://github.com/lorisleiva)! - Use peer dependencies for umi-core

## 0.4.0

### Minor Changes

- [#17](https://github.com/metaplex-foundation/umi/pull/17) [`d6ae534`](https://github.com/metaplex-foundation/umi/commit/d6ae5345ef4b8b8abca1cef04fd64e95f517e656) Thanks [@lorisleiva](https://github.com/lorisleiva)! - Add size to bytes serializer

### Patch Changes

- [#20](https://github.com/metaplex-foundation/umi/pull/20) [`9f86429`](https://github.com/metaplex-foundation/umi/commit/9f8642945f000d84b07005bebe479be9a562db87) Thanks [@lorisleiva](https://github.com/lorisleiva)! - Add new DataViewSerializer with no extra dependencies

- [#21](https://github.com/metaplex-foundation/umi/pull/21) [`8d09519`](https://github.com/metaplex-foundation/umi/commit/8d0951983756a8c147ac3f4f95bb7cfc86294aa4) Thanks [@lorisleiva](https://github.com/lorisleiva)! - Split TransactionBuilders by transaction size

## 0.3.4

### Patch Changes

- [`c93f1c4`](https://github.com/metaplex-foundation/umi/commit/c93f1c487d347fa27163d29a8caefd1d035e9052) Thanks [@lorisleiva](https://github.com/lorisleiva)! - Add empty and setItems to TransactionBuilder

## 0.3.3

### Patch Changes

- [`422dc73`](https://github.com/metaplex-foundation/umi/commit/422dc73b5a5d84e89665ef69972a90cc947a20e5) Thanks [@lorisleiva](https://github.com/lorisleiva)! - Improve get tx size logic

## 0.3.2

### Patch Changes

- [`66a7d91`](https://github.com/metaplex-foundation/umi/commit/66a7d919146ee348739438f7b0e33cc746d5d1ba) Thanks [@lorisleiva](https://github.com/lorisleiva)! - Fix setBlockhash call

## 0.3.1

### Patch Changes

- [`e566c1b`](https://github.com/metaplex-foundation/umi/commit/e566c1ba7232e1020234a750ec83607d50f60c56) Thanks [@lorisleiva](https://github.com/lorisleiva)! - Add unique helpers for PublicKeys and Signers

- [#13](https://github.com/metaplex-foundation/umi/pull/13) [`acdc77a`](https://github.com/metaplex-foundation/umi/commit/acdc77af0f6c6e231b42b22e116497908043c57c) Thanks [@lorisleiva](https://github.com/lorisleiva)! - Refactor TransactionBuilder to support Transaction sizes and LUTs

## 0.3.0

### Minor Changes

- [#10](https://github.com/metaplex-foundation/umi/pull/10) [`95d56e9`](https://github.com/metaplex-foundation/umi/commit/95d56e969b3da53e7b60758db4c530d206765697) Thanks [@lorisleiva](https://github.com/lorisleiva)! - Update Serializer interface

## 0.2.3

### Patch Changes

- [`697bddd`](https://github.com/metaplex-foundation/umi/commit/697bddd6cdd520bd1f9190eb9827c3f351512145) Thanks [@lorisleiva](https://github.com/lorisleiva)! - Add getSlot to RPC Interface

## 0.2.2

### Patch Changes

- [`e1c9595`](https://github.com/metaplex-foundation/umi/commit/e1c9595dd7f0aeb4469e86a496bc25bbb43a1b5d) Thanks [@lorisleiva](https://github.com/lorisleiva)! - Rename MetaplexError to UmiError

## 0.2.1

### Patch Changes

- [#6](https://github.com/metaplex-foundation/umi/pull/6) [`d28f4dc`](https://github.com/metaplex-foundation/umi/commit/d28f4dc05c45f35a429fa818e060aed648778718) Thanks [@lorisleiva](https://github.com/lorisleiva)! - Add support for variable string serializers

  There are now three ways to serialize/deserialize a string:

  ```ts
  // With prefix.
  umi.serializer.string().serialize('A');
  // -> 0x0100000041

  // Fixed.
  umi.serializer.fixedString(8).serialize('A');
  // -> 0x4100000000000000

  // Variable.
  umi.serializer.variableString().serialize('A');
  // -> 0x41
  ```

## 0.2.0

### Minor Changes

- [`b4d681f`](https://github.com/metaplex-foundation/umi/commit/b4d681fd173fb5cc6fe7907c610a23703695c4f6) Thanks [@lorisleiva](https://github.com/lorisleiva)! - Rename Metaplex to Umi

## 0.1.2

### Patch Changes

- [`d3ee23a`](https://github.com/metaplex-foundation/umi/commit/d3ee23aa7ee19a4c6db0e3556e58ee4d12b8ab2b) Thanks [@lorisleiva](https://github.com/lorisleiva)! - Ensure all packages are built before trying to publish

## 0.1.1

### Patch Changes

- [`f30119d`](https://github.com/metaplex-foundation/umi/commit/f30119daf5c51d893c654a064f5fabeb9246aa41) Thanks [@lorisleiva](https://github.com/lorisleiva)! - Publish a new version with changelog and a release tag
